> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/zec/cidr-block/describecidrs.md).

# DescribeCidrs

## 1. API Description

This API (DescribeCidrs) is used to query the details of one or more IPv4 CIDR blocks.

{% hint style="info" %}
**Note**

* `usedCount` is deprecated (always empty). Use `availableCount` to determine how many IP addresses are currently available in this CIDR.
* `availableCount` = `totalCount` − the number of addresses actually in use (for a block-type (Block) EIP, all addresses covered by its prefix length are counted, without excluding `.0`/`.255`).
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name  | Required | Type                                                                     | Description                                                                                                                                                                              |
| --------------- | -------- | ------------------------------------------------------------------------ | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| cidrIds         | No       | Array of String                                                          | Filter by one or more CIDR block IDs.                                                                                                                                                    |
| regionId        | No       | String                                                                   | <p>Filter by the ID of the region where the CIDR block is located.</p><p>It can be obtained by calling <a href="/api-reference/zec/location/describeregions.md">DescribeRegions</a>.</p> |
| name            | No       | String                                                                   | <p>CIDR block name.</p><p>Fuzzy search supported.</p>                                                                                                                                    |
| cidrBlock       | No       | String                                                                   | <p>CIDR IP range.</p><p>Fuzzy search supported.</p>                                                                                                                                      |
| source          | No       | [CidrCreateSource](/api-reference/zec/datastructure.md#cidrcreatesource) | IP type. IP leasing or BYOIP.                                                                                                                                                            |
| asn             | No       | Integer                                                                  | Filter by ASN.                                                                                                                                                                           |
| resourceGroupId | No       | String                                                                   | Resource Group ID.                                                                                                                                                                       |
| pageSize        | No       | Integer                                                                  | <p>Number of items in the current page result.</p><p>Default value: 20;</p><p>Value range: \[1, 1000]</p>                                                                                |
| pageNum         | No       | Integer                                                                  | <p>Number of pages returned.</p><p>Default value: 1.</p><p>Value range: \[1, +)</p><p>Default value: 1</p>                                                                               |
| tagKeys         | No       | Array of String                                                          | <p>Query using tag keys.</p><p>A maximum of 20 tag keys can be used.</p>                                                                                                                 |
| tags            | No       | Array of [Tag](/api-reference/zec/datastructure.md#tag)                  | <p>Query using tags.</p><p>A maximum of 20 tags can be used.</p>                                                                                                                         |

## 3. Output Parameters

| Parameter Name | Type                                                              | Description                                                                                                           |
| -------------- | ----------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String                                                            | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| totalCount     | Integer                                                           | Number of CIDR blocks meeting the filtering conditions.                                                               |
| dataSet        | Array of [CidrInfo](/api-reference/zec/datastructure.md#cidrinfo) | Information on CIDR blocks.                                                                                           |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**1. Query the list of CIDR blocks with CidrBlock `128.0.0.0/24`.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: DescribeCidrs
<Common Request Params>

Request：
{
  "regionId": "asia-east-1",
  "cidrBlock": "128.0.0.0/24",
  "pageSize": 10,
  "pageNum": 1
}
Response：
{
    "requestId": "TA87CE637-EDF9-423A-81C0-5A6605789BBE",
    "response": {
        "dataSet": [
            {
                "cidrBlock": "128.0.0.0/24",
                "cidrId": "<cidrId>",
                "createTime": "2026-04-28T09:22:44Z",
                "eipV4Type": "BGPLine",
                "name": "128.0.0.0/24",
                "netmask": 24,
                "networkLineType": "PremiumBGP",
                "poolId": "<poolId>",
                "regionId": "<regionId>",
                "resourceGroupId": "<resourceGroupId>",
                "resourceGroupName": "<resourceGroupName>",
                "source": "BYOIP",
                "status": "AVAILABLE",
                "asn": 12345,
                "totalCount": 20,
                "usedCount": null,
                "availableCount": 19,
                "availableCidr": [
                    {"prefixLength": 25, "count": 1},
                    {"prefixLength": 26, "count": 2},
                    {"prefixLength": 27, "count": 4}
                ],
                "asnObservation": {
                    "verificationStatus": "agreed",
                    "observedPrefix": "128.0.0.0/24",
                    "primarySource": "RIPE",
                    "primaryStatus": "FINISHED",
                    "primaryAsns": [12345]
                }
            }
        ],
        "requestId": "TA87CE637-EDF9-423A-81C0-5A6605789BBE",
        "totalCount": 1
    }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code | Description |
| ---------------- | ---------- | ----------- |
